"use strict";
const ccController_1 = require('./ccController');
class CCServiceController extends ccController_1.CCController {
    constructor(svc, router = null, debugSettings) {
        super(router, debugSettings);
        this.svc = svc;
        this.router = router;
        this.debugSettings = debugSettings;
        this.paramsKey = 'id';
    }
    setDefaultRoutes(...middlewares) {
        var r = this.router;
        let pr = this.proxied.bind(this);
        r.get('/', ...middlewares, pr(this.index));
        r.get('/:id', ...middlewares, pr(this.view));
        r.put('/', ...middlewares, pr(this.insert));
        r.delete('/', ...middlewares, pr(this.remove));
        r.post('/:id', ...middlewares, pr(this.update));
        return r;
    }
    index(req, res) {
        return this.svc.getAll();
    }
    view(req, res) {
        return this.svc.byId(req.params[this.paramsKey]);
    }
    remove(req, res) {
        return this.svc.deleteById(req.params[this.paramsKey]);
    }
    insert(req, res) {
        return this.svc.createAndSave([req.body]);
    }
    update(req, res) {
        return this.svc.updateById(req.params[this.paramsKey], req.body);
    }
}
exports.CCServiceController = CCServiceController;
